Imports System.Data.SqlClient
Imports System.IO
Imports System.IO.File

' Requires a table in the SOSOS database that looks like this:

'CREATE TABLE [Bad Software](
'	Software nvarchar(100) NOT NULL,
'	[Type] nvarchar(50) NULL,
'CONSTRAINT [BadSoftware_PK] PRIMARY KEY NONCLUSTERED 
'(
'	Software ASC
') ON [PRIMARY]
') ON [PRIMARY]

Public Class fmMain

    Private Sub bnStart_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bnStart.Click
        Dim con As New SqlConnection()
        Dim cmd As New SqlCommand()
        Dim da As New SqlDataAdapter()
        Dim dt_soft As New DataTable()
        Dim dt_bad As New DataTable()
        Dim dr_soft, dr_bad As DataRow
        Dim sw As StreamWriter
        Dim PC_name As String
        Dim found As Integer

        Me.Cursor = Cursors.WaitCursor
        ' connect to snoop
        con.ConnectionString = My.Settings.Connect_String
        Try
            con.Open()
        Catch ex As Exception
            Me.Cursor = Cursors.Default
            MsgBox("Yikes, Can't open the database" & vbCr & ex.Message, MsgBoxStyle.Critical, "Error!")
            Exit Sub
        End Try

        ' create a log file
        Try
            sw = CreateText("c:\temp\SoftwareSearch.txt")
        Catch ex As Exception
            Me.Cursor = Cursors.Default
            MsgBox("Yikes, Can't create the log file" & vbCr & ex.Message, MsgBoxStyle.Critical, "Error!")
            Exit Sub
        End Try

        ' get ready
        sw.WriteLine("Begin: " & Now())
        tbStatus.Text = "Connecting..."
        Application.DoEvents()

        ' a command object to get the data
        cmd.Connection = con
        cmd.CommandText = "Select * from Software order by ID_Software"

        ' pull a disconnected copy
        da.SelectCommand = cmd
        da.Fill(dt_soft)

        ' again for second table
        cmd.CommandText = "Select * from [Bad Software]"
        da.Fill(dt_bad)

        ' do the search
        found = 0
        For Each dr_soft In dt_soft.Rows
            PC_name = Split(dr_soft("ID_Software").ToString, "(")(0)
            tbStatus.Text = PC_name
            Application.DoEvents()

            For Each dr_bad In dt_bad.Rows
                If dr_soft("Software").ToString Like "*" & dr_bad("Software").ToString.Trim & "*" Then
                    ' found one!
                    sw.WriteLine(PC_name & ", " & dr_bad("Software").ToString.Trim & ", " & dr_soft("Software").ToString)
                    found = found + 1
                End If
            Next
        Next

        sw.WriteLine("Finish: " & Now())
        tbStatus.Text = "Done!"
        sw.Close()
        con.Close()

        Me.Cursor = Cursors.Default
        MsgBox("Done!" & vbCrLf & "Found " & found & " occurances" & vbCrLf & "Wrote to c:\temp\SoftwareSearch.txt", MsgBoxStyle.Information)
    End Sub

    Private Sub bnView_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bnView.Click
        If [File].Exists("c:\temp\SoftwareSearch.txt") Then
            Shell("notepad.exe c:\temp\SoftwareSearch.txt", AppWinStyle.NormalFocus)
        End If
    End Sub

    Private Sub bnQuit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bnQuit.Click
        Me.Close()
    End Sub
End Class
